Index: kernel/tgb.cc
===================================================================
--- kernel/tgb.cc	(revision a41623dd1e56318466dc81751481d37d19489c7b)
+++ kernel/tgb.cc	(revision 410ea0fb1e22ebcb52e33b6789cf294a2d1f663b)
@@ -2784,105 +3045,111 @@
 #ifdef REDTAIL_S
 
-static poly redNFTail (poly h,const int sl,kStrategy strat, int len)
-{
-  BOOLEAN nc=rIsPluralRing(currRing);
-  if (h==NULL) return NULL;
-  pTest(h);
+static poly
+redNFTail (poly h, const int sl, kStrategy strat, int len)
+{
+  BOOLEAN nc = rIsPluralRing (currRing);
+  if (h == NULL)
+    return NULL;
+  pTest (h);
   if (0 > sl)
     return h;
-  if (pNext(h)==NULL) return h;
+  if (pNext (h) == NULL)
+    return h;
 
   int j;
-  poly res=h;
-  poly act=res;
-  LObject P(pNext(h));
-  pNext(res)=NULL;
-  P.bucket = kBucketCreate(currRing);
+  poly res = h;
+  poly act = res;
+  LObject P (pNext (h));
+  pNext (res) = NULL;
+  P.bucket = kBucketCreate (currRing);
   len--;
-  h=P.p;
-  if (len <=0) len=pLength(h);
-  kBucketInit(P.bucket,h /*P.p*/,len /*pLength(P.p)*/);
-  pTest(h);
+  h = P.p;
+  if (len <= 0)
+    len = pLength (h);
+  kBucketInit (P.bucket, h /*P.p */ , len /*pLength(P.p) */ );
+  pTest (h);
   loop
   {
-      P.p=h;
-      P.t_p=NULL;
-      P.SetShortExpVector();
-      loop
-      {
-          //int dummy=strat->sl;
-          j=kFindDivisibleByInS_easy(strat,P.p,P.sev);//kFindDivisibleByInS(strat,&dummy,&P);
-          if (j>=0)
-          {
+    P.p = h;
+    P.t_p = NULL;
+    P.SetShortExpVector ();
+    loop
+    {
+      //int dummy=strat->sl;
+      j = kFindDivisibleByInS_easy (strat, P.p, P.sev);	//kFindDivisibleByInS(strat,&dummy,&P);
+      if (j >= 0)
+      {
 #ifdef REDTAIL_PROT
-            PrintS("r");
-#endif
-            nNormalize(pGetCoeff(P.p));
+	PrintS ("r");
+#endif
+	nNormalize (pGetCoeff (P.p));
 #ifdef KDEBUG
-            if (TEST_OPT_DEBUG)
-            {
-              PrintS("red tail:");
-              wrp(h);
-              PrintS(" with ");
-              wrp(strat->S[j]);
-            }
-#endif
-            number coef;
-            pTest(strat->S[j]);
+	if (TEST_OPT_DEBUG)
+	{
+	  PrintS ("red tail:");
+	  wrp (h);
+	  PrintS (" with ");
+	  wrp (strat->S[j]);
+	}
+#endif
+	number coef;
+	pTest (strat->S[j]);
 #ifdef HAVE_PLURAL
-            if (nc)
-            {
-              nc_BucketPolyRed_Z(P.bucket, strat->S[j], &coef);
-            }
-            else
-#endif
-              coef=kBucketPolyRed(P.bucket,strat->S[j],
-                                strat->lenS[j]/*pLength(strat->S[j])*/,strat->kNoether);
-            pMult_nn(res,coef);
-            nDelete(&coef);
-            h = kBucketGetLm(P.bucket);
-            pTest(h);
-            if (h==NULL)
-            {
+	if (nc)
+	{
+	  nc_BucketPolyRed_Z (P.bucket, strat->S[j], &coef);
+	}
+	else
+#endif
+	  coef = kBucketPolyRed (P.bucket, strat->S[j],
+				 strat->lenS[j] /*pLength(strat->S[j]) */ ,
+				 strat->kNoether);
+	pMult_nn (res, coef);
+	nDelete (&coef);
+	h = kBucketGetLm (P.bucket);
+	pTest (h);
+	if (h == NULL)
+	{
 #ifdef REDTAIL_PROT
-              PrintS(" ");
-#endif
-        kBucketDestroy(&P.bucket);
-              return res;
-            }
-            pTest(h);
-            P.p=h;
-            P.t_p=NULL;
-            P.SetShortExpVector();
+	  PrintS (" ");
+#endif
+	  kBucketDestroy (&P.bucket);
+	  return res;
+	}
+	pTest (h);
+	P.p = h;
+	P.t_p = NULL;
+	P.SetShortExpVector ();
 #ifdef KDEBUG
-            if (TEST_OPT_DEBUG)
-            {
-              PrintS("\nto tail:");
-              wrp(h);
-              PrintLn();
-            }
-#endif
-          }
-          else
-          {
+	if (TEST_OPT_DEBUG)
+	{
+	  PrintS ("\nto tail:");
+	  wrp (h);
+	  PrintLn ();
+	}
+#endif
+      }
+      else
+      {
 #ifdef REDTAIL_PROT
-            PrintS("n");
-#endif
-            break;
-          }
-      } /* end loop current mon */
-      //   poly tmp=pHead(h /*kBucketGetLm(P.bucket)*/);
-      //act->next=tmp;pIter(act);
-      act->next=kBucketExtractLm(P.bucket);pIter(act);
-      h = kBucketGetLm(P.bucket);
-      if (h==NULL)
-      {
+	PrintS ("n");
+#endif
+	break;
+      }
+    }				/* end loop current mon */
+    //   poly tmp=pHead(h /*kBucketGetLm(P.bucket)*/);
+    //act->next=tmp;pIter(act);
+    act->next = kBucketExtractLm (P.bucket);
+    pIter (act);
+    h = kBucketGetLm (P.bucket);
+    if (h == NULL)
+    {
 #ifdef REDTAIL_PROT
-        PrintS(" ");
-#endif
-  kBucketDestroy(&P.bucket);
-        return res;
-      }
-      pTest(h);
+      PrintS (" ");
+#endif
+      kBucketDestroy (&P.bucket);
+      return res;
+    }
+    pTest (h);
   }
 }
@@ -2893,30 +3160,34 @@
 
 //transfers ownership of m to mat
-void init_with_mac_poly(tgb_sparse_matrix* mat, int row, mac_poly m)
-{
-  assume(mat->mp[row]==NULL);
-  mat->mp[row]=m;
+void
+init_with_mac_poly (tgb_sparse_matrix * mat, int row, mac_poly m)
+{
+  assume (mat->mp[row] == NULL);
+  mat->mp[row] = m;
 #ifdef TGB_DEBUG
-  mac_poly r=m;
-  while(r)
-  {
-    assume(r->exp<mat->columns);
-    r=r->next;
-  }
-#endif
-}
-poly free_row_to_poly(tgb_sparse_matrix* mat, int row, poly* monoms, int monom_index)
-{
-  poly p=NULL;
-  poly* set_this=&p;
-  mac_poly r=mat->mp[row];
-  mat->mp[row]=NULL;
-  while(r)
-  {
-    (*set_this)=pLmInit(monoms[monom_index-1-r->exp]);
-    pSetCoeff((*set_this),r->coef);
-    set_this=&((*set_this)->next);
-    mac_poly old=r;
-    r=r->next;
+  mac_poly r = m;
+  while (r)
+  {
+    assume (r->exp < mat->columns);
+    r = r->next;
+  }
+#endif
+}
+
+poly
+free_row_to_poly (tgb_sparse_matrix * mat, int row, poly * monoms,
+		  int monom_index)
+{
+  poly p = NULL;
+  poly *set_this = &p;
+  mac_poly r = mat->mp[row];
+  mat->mp[row] = NULL;
+  while (r)
+  {
+    (*set_this) = pLmInit (monoms[monom_index - 1 - r->exp]);
+    pSetCoeff ((*set_this), r->coef);
+    set_this = &((*set_this)->next);
+    mac_poly old = r;
+    r = r->next;
     delete old;
 
@@ -2925,370 +3196,387 @@
 }
 
-static int poly_crit(const void* ap1, const void* ap2)
-{
-  poly p1,p2;
-  p1=*((poly*) ap1);
-  p2=*((poly*)ap2);
-
-  int c=pLmCmp(p1,p2);
-  if (c !=0) return c;
-  int l1=pLength(p1);
-  int l2=pLength(p2);
-  if (l1<l2) return -1;
-  if (l1>l2) return 1;
+static int
+poly_crit (const void *ap1, const void *ap2)
+{
+  poly p1, p2;
+  p1 = *((poly *) ap1);
+  p2 = *((poly *) ap2);
+
+  int c = pLmCmp (p1, p2);
+  if (c != 0)
+    return c;
+  int l1 = pLength (p1);
+  int l2 = pLength (p2);
+  if (l1 < l2)
+    return -1;
+  if (l1 > l2)
+    return 1;
   return 0;
 }
 
-void slimgb_alg::introduceDelayedPairs(poly* pa,int s)
-{
-    if (s==0) return;
-    sorted_pair_node** si_array=(sorted_pair_node**) omalloc(s* sizeof(sorted_pair_node*));
-
-    for( int i = 0; i < s; i++ )
-    {
-        sorted_pair_node* si=(sorted_pair_node*) omalloc(sizeof(sorted_pair_node));
-        si->i=-1;
-        si->j=-2;
-        poly p=pa[i];
-        simplify_poly(p,r);
-        si->expected_length=pQuality(p,this,pLength(p));
-        p_Test(p,r);
-        si->deg=this->pTotaldegree_full(p);
-        /*if (!rField_is_Zp(r))
+void
+slimgb_alg::introduceDelayedPairs (poly * pa, int s)
+{
+  if (s == 0)
+    return;
+  sorted_pair_node **si_array =
+    (sorted_pair_node **) omalloc (s * sizeof (sorted_pair_node *));
+
+  for (int i = 0; i < s; i++)
+  {
+    sorted_pair_node *si =
+      (sorted_pair_node *) omalloc (sizeof (sorted_pair_node));
+    si->i = -1;
+    si->j = -2;
+    poly p = pa[i];
+    simplify_poly (p, r);
+    si->expected_length = pQuality (p, this, pLength (p));
+    p_Test (p, r);
+    si->deg = this->pTotaldegree_full (p);
+    /*if (!rField_is_Zp(r))
        {
-          p_Content(p,r);
-          p_Cleardenom(p,r);
-        }*/
-
-        si->lcm_of_lm=p;
-
-        //      c->apairs[n-1-i]=si;
-        si_array[i]=si;
-  }
-
-  qsort(si_array,s,sizeof(sorted_pair_node*),tgb_pair_better_gen2);
-    apairs=spn_merge(apairs,pair_top+1,si_array,s,this);
-  pair_top+=s;
-  omfree(si_array);
-}
-
-slimgb_alg::slimgb_alg(ideal I, int syz_comp,BOOLEAN F4,int deg_pos)
-{
-  this->deg_pos=deg_pos;
-  lastCleanedDeg=-1;
-  completed=FALSE;
-  this->syz_comp=syz_comp;
-  r=currRing;
-  nc=rIsPluralRing(r);
-  this->lastDpBlockStart=get_last_dp_block_start(r);
+       p_Content(p,r);
+       p_Cleardenom(p,r);
+       } */
+
+    si->lcm_of_lm = p;
+
+    //      c->apairs[n-1-i]=si;
+    si_array[i] = si;
+  }
+
+  qsort (si_array, s, sizeof (sorted_pair_node *), tgb_pair_better_gen2);
+  apairs = spn_merge (apairs, pair_top + 1, si_array, s, this);
+  pair_top += s;
+  omfree (si_array);
+}
+
+slimgb_alg::slimgb_alg (ideal I, int syz_comp, BOOLEAN F4, int deg_pos)
+{
+  this->deg_pos = deg_pos;
+  lastCleanedDeg = -1;
+  completed = FALSE;
+  this->syz_comp = syz_comp;
+  r = currRing;
+  nc = rIsPluralRing (r);
+  this->lastDpBlockStart = get_last_dp_block_start (r);
   //Print("last dp Block start: %i\n", this->lastDpBlockStart);
-  is_homog=TRUE;
+  is_homog = TRUE;
   {
     int hzz;
-    for(hzz=0;hzz<IDELEMS(I);hzz++)
-    {
-      assume(I->m[hzz]!=NULL);
-      int d=this->pTotaldegree(I->m[hzz]);
-      poly t=I->m[hzz]->next;
-      while(t)
-      {
-        if (d!=this->pTotaldegree(t))
-        {
-          is_homog=FALSE;
-          break;
-        }
-        t=t->next;
-      }
-      if(!(is_homog)) break;
-    }
-  }
-  eliminationProblem=((!(is_homog))&&((pLexOrder)||(I->rank>1)));
-  tailReductions=((is_homog)||((TEST_OPT_REDTAIL)&&(!(I->rank>1))));
+    for (hzz = 0; hzz < IDELEMS (I); hzz++)
+    {
+      assume (I->m[hzz] != NULL);
+      int d = this->pTotaldegree (I->m[hzz]);
+      poly t = I->m[hzz]->next;
+      while (t)
+      {
+	if (d != this->pTotaldegree (t))
+	{
+	  is_homog = FALSE;
+	  break;
+	}
+	t = t->next;
+      }
+      if (!(is_homog))
+	break;
+    }
+  }
+  eliminationProblem = ((!(is_homog)) && ((pLexOrder) || (I->rank > 1)));
+  tailReductions = ((is_homog) || ((TEST_OPT_REDTAIL) && (!(I->rank > 1))));
   //  Print("is homog:%d",c->is_homog);
-  void* h;
+  void *h;
   int i;
-  to_destroy=NULL;
-  easy_product_crit=0;
-  extended_product_crit=0;
-  if (rField_is_Zp(r))
-    isDifficultField=FALSE;
+  to_destroy = NULL;
+  easy_product_crit = 0;
+  extended_product_crit = 0;
+  if (rField_is_Zp (r))
+    isDifficultField = FALSE;
   else
-    isDifficultField=TRUE;
+    isDifficultField = TRUE;
   //not fully correct
   //(rChar()==0);
-  F4_mode=F4;
-
-  reduction_steps=0;
-  last_index=-1;
-
-  F=NULL;
-  F_minus=NULL;
-
-  Rcounter=0;
-
-  soon_free=NULL;
-
-  tmp_lm=pOne();
-
-  normal_forms=0;
-  current_degree=1;
-
-  max_pairs=5*IDELEMS(I);
-
-  apairs=(sorted_pair_node**) omalloc(sizeof(sorted_pair_node*)*max_pairs);
-  pair_top=-1;
-
-  int n=IDELEMS(I);
-  array_lengths=n;
-
-
-  i=0;
-  this->n=0;
-  T_deg=(int*) omalloc(n*sizeof(int));
-  if(eliminationProblem)
-    T_deg_full=(int*) omalloc(n*sizeof(int));
+  F4_mode = F4;
+
+  reduction_steps = 0;
+  last_index = -1;
+
+  F = NULL;
+  F_minus = NULL;
+
+  Rcounter = 0;
+
+  soon_free = NULL;
+
+  tmp_lm = pOne ();
+
+  normal_forms = 0;
+  current_degree = 1;
+
+  max_pairs = 5 * IDELEMS (I);
+
+  apairs =
+    (sorted_pair_node **) omalloc (sizeof (sorted_pair_node *) * max_pairs);
+  pair_top = -1;
+
+  int n = IDELEMS (I);
+  array_lengths = n;
+
+
+  i = 0;
+  this->n = 0;
+  T_deg = (int *) omalloc (n * sizeof (int));
+  if (eliminationProblem)
+    T_deg_full = (int *) omalloc (n * sizeof (int));
   else
-    T_deg_full=NULL;
-  tmp_pair_lm=(poly*) omalloc(n*sizeof(poly));
-  tmp_spn=(sorted_pair_node**) omalloc(n*sizeof(sorted_pair_node*));
-  lm_bin=omGetSpecBin(POLYSIZE + (r->ExpL_Size)*sizeof(long));
+    T_deg_full = NULL;
+  tmp_pair_lm = (poly *) omalloc (n * sizeof (poly));
+  tmp_spn = (sorted_pair_node **) omalloc (n * sizeof (sorted_pair_node *));
+  lm_bin = omGetSpecBin (POLYSIZE + (r->ExpL_Size) * sizeof (long));
 #ifdef HEAD_BIN
-  HeadBin=omGetSpecBin(POLYSIZE + (currRing->ExpL_Size)*sizeof(long));
+  HeadBin = omGetSpecBin (POLYSIZE + (currRing->ExpL_Size) * sizeof (long));
 #endif
   /* omUnGetSpecBin(&(c->HeadBin)); */
-  #ifndef HAVE_BOOST
-  #ifdef USE_STDVECBOOL
-  #else
-  h=omalloc(n*sizeof(char*));
-
-  states=(char**) h;
-  #endif
-  #endif
-  h=omalloc(n*sizeof(int));
-  lengths=(int*) h;
-  weighted_lengths=(wlen_type*)omalloc(n*sizeof(wlen_type));
-  gcd_of_terms=(poly*) omalloc(n*sizeof(poly));
-
-  short_Exps=(long*) omalloc(n*sizeof(long));
+#ifndef HAVE_BOOST
+#ifdef USE_STDVECBOOL
+#else
+  h = omalloc (n * sizeof (char *));
+
+  states = (char **) h;
+#endif
+#endif
+  h = omalloc (n * sizeof (int));
+  lengths = (int *) h;
+  weighted_lengths = (wlen_type *) omalloc (n * sizeof (wlen_type));
+  gcd_of_terms = (poly *) omalloc (n * sizeof (poly));
+
+  short_Exps = (long *) omalloc (n * sizeof (long));
   if (F4_mode)
-    S=idInit(n,I->rank);
+    S = idInit (n, I->rank);
   else
-    S=idInit(1,I->rank);
-  strat=new skStrategy;
+    S = idInit (1, I->rank);
+  strat = new skStrategy;
   if (eliminationProblem)
-    strat->honey=TRUE;
+    strat->honey = TRUE;
   strat->syzComp = 0;
-  initBuchMoraCrit(strat);
-  initBuchMoraPos(strat);
+  initBuchMoraCrit (strat);
+  initBuchMoraPos (strat);
   strat->initEcart = initEcartBBA;
-  strat->tailRing=r;
+  strat->tailRing = r;
   strat->enterS = enterSBba;
   strat->sl = -1;
-  i=n;
-  i=1;//some strange bug else
+  i = n;
+  i = 1;			//some strange bug else
   /* initS(c->S,NULL,c->strat); */
   /* intS start: */
   // i=((i+IDELEMS(c->S)+15)/16)*16;
-  strat->ecartS=(intset)omAlloc(i*sizeof(int)); /*initec(i);*/
-  strat->sevS=(unsigned long*)omAlloc0(i*sizeof(unsigned long));
-  /*initsevS(i);*/
-  strat->S_2_R=(int*)omAlloc0(i*sizeof(int));/*initS_2_R(i);*/
-  strat->fromQ=NULL;
-  strat->Shdl=idInit(1,1);
-  strat->S=strat->Shdl->m;
-  strat->lenS=(int*)omAlloc0(i*sizeof(int));
-  if((isDifficultField)||(eliminationProblem))
-    strat->lenSw=(wlen_type*)omAlloc0(i*sizeof(wlen_type));
+  strat->ecartS = (intset) omAlloc (i * sizeof (int));	/*initec(i); */
+  strat->sevS = (unsigned long *) omAlloc0 (i * sizeof (unsigned long));
+  /*initsevS(i); */
+  strat->S_2_R = (int *) omAlloc0 (i * sizeof (int));	/*initS_2_R(i); */
+  strat->fromQ = NULL;
+  strat->Shdl = idInit (1, 1);
+  strat->S = strat->Shdl->m;
+  strat->lenS = (int *) omAlloc0 (i * sizeof (int));
+  if ((isDifficultField) || (eliminationProblem))
+    strat->lenSw = (wlen_type *) omAlloc0 (i * sizeof (wlen_type));
   else
-    strat->lenSw=NULL;
-  assume(n>0);
-  add_to_basis_ideal_quotient(I->m[0],this,NULL);
-
-  assume(strat->sl==IDELEMS(strat->Shdl)-1);
-  if(!(F4_mode))
-  {
-        poly* array_arg=I->m;
-        array_arg++;
-        introduceDelayedPairs(array_arg,n-1);
-        /*
-    for (i=1;i<n;i++)//the 1 is wanted, because first element is added to basis
-    {
-      //     add_to_basis(I->m[i],-1,-1,c);
-      si=(sorted_pair_node*) omalloc(sizeof(sorted_pair_node));
-      si->i=-1;
-      si->j=-2;
-      si->expected_length=pQuality(I->m[i],this,pLength(I->m[i]));
-      si->deg=pTotaldegree(I->m[i]);
-      if (!rField_is_Zp(r))
-      {
-        p_Cleardenom(I->m[i], r);
-      }
-      si->lcm_of_lm=I->m[i];
-
-      //      c->apairs[n-1-i]=si;
-      apairs[n-i-1]=si;
-      ++(pair_top);
-    }*/
+    strat->lenSw = NULL;
+  assume (n > 0);
+  add_to_basis_ideal_quotient (I->m[0], this, NULL);
+
+  assume (strat->sl == IDELEMS (strat->Shdl) - 1);
+  if (!(F4_mode))
+  {
+    poly *array_arg = I->m;
+    array_arg++;
+    introduceDelayedPairs (array_arg, n - 1);
+    /*
+       for (i=1;i<n;i++)//the 1 is wanted, because first element is added to basis
+       {
+       //     add_to_basis(I->m[i],-1,-1,c);
+       si=(sorted_pair_node*) omalloc(sizeof(sorted_pair_node));
+       si->i=-1;
+       si->j=-2;
+       si->expected_length=pQuality(I->m[i],this,pLength(I->m[i]));
+       si->deg=pTotaldegree(I->m[i]);
+       if (!rField_is_Zp(r))
+       {
+       p_Cleardenom(I->m[i], r);
+       }
+       si->lcm_of_lm=I->m[i];
+
+       //      c->apairs[n-1-i]=si;
+       apairs[n-i-1]=si;
+       ++(pair_top);
+       } */
   }
   else
   {
-    for (i=1;i<n;i++)//the 1 is wanted, because first element is added to basis
-      add_to_basis_ideal_quotient(I->m[i],this,NULL);
-  }
-  for(i=0;i<IDELEMS(I);i++)
-  {
-    I->m[i]=NULL;
-  }
-  idDelete(&I);
-  add_later=idInit(ADD_LATER_SIZE,S->rank);
-  #ifdef USE_NORO
-  use_noro=((!(nc))&&(S->rank<=1)&&(rField_is_Zp(r)) &&(!(eliminationProblem))&&(npPrimeM<=32003));
-  use_noro_last_block=false;
-  if ((!(use_noro))&&(lastDpBlockStart<=pVariables))
-  {
-      use_noro_last_block=((!(nc))&&(S->rank<=1)&&(rField_is_Zp(r)) &&(npPrimeM<=32003));
-  }
-  #else
-  use_noro=false;
-  use_noro_last_block=false;
-  #endif
+    for (i = 1; i < n; i++)	//the 1 is wanted, because first element is added to basis
+      add_to_basis_ideal_quotient (I->m[i], this, NULL);
+  }
+  for (i = 0; i < IDELEMS (I); i++)
+  {
+    I->m[i] = NULL;
+  }
+  idDelete (&I);
+  add_later = idInit (ADD_LATER_SIZE, S->rank);
+#ifdef USE_NORO
+  use_noro = ((!(nc)) && (S->rank <= 1) && (rField_is_Zp (r))
+	      && (!(eliminationProblem)) && (npPrimeM <= 32003));
+  use_noro_last_block = false;
+  if ((!(use_noro)) && (lastDpBlockStart <= pVariables))
+  {
+    use_noro_last_block = ((!(nc)) && (S->rank <= 1) && (rField_is_Zp (r))
+			   && (npPrimeM <= 32003));
+  }
+#else
+  use_noro = false;
+  use_noro_last_block = false;
+#endif
   //Print("NORO last block %i",use_noro_last_block);
-  memset(add_later->m,0,ADD_LATER_SIZE*sizeof(poly));
-}
-slimgb_alg::~slimgb_alg()
+  memset (add_later->m, 0, ADD_LATER_SIZE * sizeof (poly));
+}
+
+slimgb_alg::~slimgb_alg ()
 {
 
   if (!(completed))
   {
-      poly* add=(poly*) omalloc((pair_top+2)*sizeof(poly));
-      int piter;
-      int pos=0;
-      for(piter=0;piter<=pair_top;piter++)
-      {
-        sorted_pair_node* s=apairs[piter];
-        if (s->i<0)
-        {
-            //delayed element
-            if (s->lcm_of_lm!=NULL)
-            {
-                add[pos]=s->lcm_of_lm;
-                pos++;
-            }
-        }
-        free_sorted_pair_node(s,r);
-        apairs[piter]=NULL;
-      }
-      pair_top=-1;
-      add[pos]=NULL;
-      pos=0;
-      while(add[pos]!=NULL)
-      {
-        add_to_basis_ideal_quotient(add[pos],this,NULL);
-        pos++;
-      }
-      for(piter=0;piter<=pair_top;piter++)
-      {
-        sorted_pair_node* s=apairs[piter];
-        assume(s->i>=0);
-        free_sorted_pair_node(s,r);
-        apairs[piter]=NULL;
-      }
-      pair_top=-1;
-  }
-  id_Delete(&add_later,r);
-  int i,j;
-  slimgb_alg* c=this;
-  while(c->to_destroy)
-  {
-    pDelete(&(c->to_destroy->p));
-    poly_list_node* old=c->to_destroy;
-    c->to_destroy=c->to_destroy->next;
-    omfree(old);
-  }
-  while(c->F)
-  {
-    for(i=0;i<c->F->size;i++)
-    {
-      pDelete(&(c->F->mp[i].m));
-    }
-    omfree(c->F->mp);
-    c->F->mp=NULL;
-    mp_array_list* old=c->F;
-    c->F=c->F->next;
-    omfree(old);
-  }
-  while(c->F_minus)
-  {
-    for(i=0;i<c->F_minus->size;i++)
-    {
-      pDelete(&(c->F_minus->p[i]));
-    }
-    omfree(c->F_minus->p);
-    c->F_minus->p=NULL;
-    poly_array_list* old=c->F_minus;
-    c->F_minus=c->F_minus->next;
-    omfree(old);
-  }
-  #ifndef HAVE_BOOST
-  #ifndef USE_STDVECBOOL
-  for(int z=1 /* zero length at 0 */;z<c->n;z++)
-  {
-    omfree(c->states[z]);
-  }
-  omfree(c->states);
-  #endif
-  #endif
-
-  omfree(c->lengths);
-  omfree(c->weighted_lengths);
-  for(int z=0;z<c->n;z++)
-  {
-    pDelete(&c->tmp_pair_lm[z]);
-    omfree(c->tmp_spn[z]);
-  }
-  omfree(c->tmp_pair_lm);
-  omfree(c->tmp_spn);
-
-  omfree(c->T_deg);
-  if(c->T_deg_full)
-    omfree(c->T_deg_full);
-
-  omFree(c->strat->ecartS);
-  omFree(c->strat->sevS);
+    poly *add = (poly *) omalloc ((pair_top + 2) * sizeof (poly));
+    int piter;
+    int pos = 0;
+    for (piter = 0; piter <= pair_top; piter++)
+    {
+      sorted_pair_node *s = apairs[piter];
+      if (s->i < 0)
+      {
+	//delayed element
+	if (s->lcm_of_lm != NULL)
+	{
+	  add[pos] = s->lcm_of_lm;
+	  pos++;
+	}
+      }
+      free_sorted_pair_node (s, r);
+      apairs[piter] = NULL;
+    }
+    pair_top = -1;
+    add[pos] = NULL;
+    pos = 0;
+    while (add[pos] != NULL)
+    {
+      add_to_basis_ideal_quotient (add[pos], this, NULL);
+      pos++;
+    }
+    for (piter = 0; piter <= pair_top; piter++)
+    {
+      sorted_pair_node *s = apairs[piter];
+      assume (s->i >= 0);
+      free_sorted_pair_node (s, r);
+      apairs[piter] = NULL;
+    }
+    pair_top = -1;
+  }
+  id_Delete (&add_later, r);
+  int i, j;
+  slimgb_alg *c = this;
+  while (c->to_destroy)
+  {
+    pDelete (&(c->to_destroy->p));
+    poly_list_node *old = c->to_destroy;
+    c->to_destroy = c->to_destroy->next;
+    omfree (old);
+  }
+  while (c->F)
+  {
+    for (i = 0; i < c->F->size; i++)
+    {
+      pDelete (&(c->F->mp[i].m));
+    }
+    omfree (c->F->mp);
+    c->F->mp = NULL;
+    mp_array_list *old = c->F;
+    c->F = c->F->next;
+    omfree (old);
+  }
+  while (c->F_minus)
+  {
+    for (i = 0; i < c->F_minus->size; i++)
+    {
+      pDelete (&(c->F_minus->p[i]));
+    }
+    omfree (c->F_minus->p);
+    c->F_minus->p = NULL;
+    poly_array_list *old = c->F_minus;
+    c->F_minus = c->F_minus->next;
+    omfree (old);
+  }
+#ifndef HAVE_BOOST
+#ifndef USE_STDVECBOOL
+  for (int z = 1 /* zero length at 0 */ ; z < c->n; z++)
+  {
+    omfree (c->states[z]);
+  }
+  omfree (c->states);
+#endif
+#endif
+
+  omfree (c->lengths);
+  omfree (c->weighted_lengths);
+  for (int z = 0; z < c->n; z++)
+  {
+    pDelete (&c->tmp_pair_lm[z]);
+    omfree (c->tmp_spn[z]);
+  }
+  omfree (c->tmp_pair_lm);
+  omfree (c->tmp_spn);
+
+  omfree (c->T_deg);
+  if (c->T_deg_full)
+    omfree (c->T_deg_full);
+
+  omFree (c->strat->ecartS);
+  omFree (c->strat->sevS);
 //   initsevS(i);
-  omFree(c->strat->S_2_R);
-
-
-  omFree(c->strat->lenS);
-
-  if(c->strat->lenSw)  omFree(c->strat->lenSw);
-
-  for(i=0;i<c->n;i++)
-  {
-    if(c->gcd_of_terms[i])
-      pDelete(&(c->gcd_of_terms[i]));
-  }
-  omfree(c->gcd_of_terms);
-
-  omfree(c->apairs);
+  omFree (c->strat->S_2_R);
+
+
+  omFree (c->strat->lenS);
+
+  if (c->strat->lenSw)
+    omFree (c->strat->lenSw);
+
+  for (i = 0; i < c->n; i++)
+  {
+    if (c->gcd_of_terms[i])
+      pDelete (&(c->gcd_of_terms[i]));
+  }
+  omfree (c->gcd_of_terms);
+
+  omfree (c->apairs);
   if (TEST_OPT_PROT)
   {
     //Print("calculated %d NFs\n",c->normal_forms);
-      Print("\nNF:%i product criterion:%i, ext_product criterion:%i \n", c->normal_forms, c->easy_product_crit, c->extended_product_crit);
-  }
-
-  for(i=0;i<=c->strat->sl;i++)
-  {
-    if (!c->strat->S[i]) continue;
-    BOOLEAN found=FALSE;
-    for(j=0;j<c->n;j++)
-    {
-      if (c->S->m[j]==c->strat->S[i])
-      {
-        found=TRUE;
-        break;
-      }
-    }
-    if(!found) pDelete(&c->strat->S[i]);
+    Print ("\nNF:%i product criterion:%i, ext_product criterion:%i \n",
+	   c->normal_forms, c->easy_product_crit, c->extended_product_crit);
+  }
+
+  for (i = 0; i <= c->strat->sl; i++)
+  {
+    if (!c->strat->S[i])
+      continue;
+    BOOLEAN found = FALSE;
+    for (j = 0; j < c->n; j++)
+    {
+      if (c->S->m[j] == c->strat->S[i])
+      {
+	found = TRUE;
+	break;
+      }
+    }
+    if (!found)
+      pDelete (&c->strat->S[i]);
   }
 //   for(i=0;i<c->n;i++)
@@ -3311,87 +3599,90 @@
   if (completed)
   {
-  for(i=0;i<c->n;i++)
-  {
-    assume(c->S->m[i]!=NULL);
-    if (p_GetComp(c->S->m[i],currRing)>this->syz_comp) continue;
-    for(j=0;j<c->n;j++)
-    {
-      if((c->S->m[j]==NULL)||(i==j))
-        continue;
-      assume(p_LmShortDivisibleBy(c->S->m[j],c->short_Exps[j],
-             c->S->m[i],~c->short_Exps[i],
-             c->r)==p_LmDivisibleBy(c->S->m[j],
-             c->S->m[i],
-             c->r));
-      if (p_LmShortDivisibleBy(c->S->m[j],c->short_Exps[j],
-          c->S->m[i],~c->short_Exps[i],
-          c->r))
-      {
-        pDelete(&c->S->m[i]);
-        break;
-      }
-    }
-  }
-  }
-  omfree(c->short_Exps);
-
-  ideal I=c->S;
-  IDELEMS(I)=c->n;
-  idSkipZeroes(I);
-  for(i=0;i<=c->strat->sl;i++)
-    c->strat->S[i]=NULL;
-  id_Delete(&c->strat->Shdl,c->r);
-  pDelete(&c->tmp_lm);
-  omUnGetSpecBin(&lm_bin);
+    for (i = 0; i < c->n; i++)
+    {
+      assume (c->S->m[i] != NULL);
+      if (p_GetComp (c->S->m[i], currRing) > this->syz_comp)
+	continue;
+      for (j = 0; j < c->n; j++)
+      {
+	if ((c->S->m[j] == NULL) || (i == j))
+	  continue;
+	assume (p_LmShortDivisibleBy (c->S->m[j], c->short_Exps[j],
+				      c->S->m[i], ~c->short_Exps[i],
+				      c->r) == p_LmDivisibleBy (c->S->m[j],
+								c->S->m[i],
+								c->r));
+	if (p_LmShortDivisibleBy (c->S->m[j], c->short_Exps[j],
+				  c->S->m[i], ~c->short_Exps[i], c->r))
+	{
+	  pDelete (&c->S->m[i]);
+	  break;
+	}
+      }
+    }
+  }
+  omfree (c->short_Exps);
+
+  ideal I = c->S;
+  IDELEMS (I) = c->n;
+  idSkipZeroes (I);
+  for (i = 0; i <= c->strat->sl; i++)
+    c->strat->S[i] = NULL;
+  id_Delete (&c->strat->Shdl, c->r);
+  pDelete (&c->tmp_lm);
+  omUnGetSpecBin (&lm_bin);
   delete c->strat;
 }
-ideal t_rep_gb(ring r,ideal arg_I, int syz_comp, BOOLEAN F4_mode)
-{
-    assume(r==currRing);
-    ring orig_ring=r;
-    int pos;
-    ring new_ring=rAssure_TDeg(orig_ring,1,rVar(orig_ring),pos);
-    ideal s_h;
-    if (orig_ring != new_ring)
-    {
-        rChangeCurrRing(new_ring);
-        s_h=idrCopyR_NoSort(arg_I,orig_ring);
-        idTest(s_h);
-        /*int i;
-        for(i=0;i<IDELEMS(s_h);i++)
-        {
-            poly p=s_h->m[i];
-            while(p)
-            {
-                p_Setm(p,new_ring);
-                pIter(p);
-            }
-        }*/
-    }
-    else
-    {
-        s_h = id_Copy(arg_I,orig_ring);
-    }
-
-    ideal s_result=do_t_rep_gb(new_ring,s_h,syz_comp,F4_mode,pos);
-    ideal result;
-    if(orig_ring != new_ring)
-    {
-        idTest(s_result);
-        rChangeCurrRing(orig_ring);
-        result = idrMoveR_NoSort(s_result, new_ring);
-
-        idTest(result);
-        //rChangeCurrRing(new_ring);
-        rKill(new_ring);
-        //rChangeCurrRing(orig_ring);
-    }
-    else
-        result=s_result;
-    idTest(result);
-    return result;
-}
-
-ideal do_t_rep_gb(ring r,ideal arg_I, int syz_comp, BOOLEAN F4_mode,int deg_pos)
+
+ideal
+t_rep_gb (ring r, ideal arg_I, int syz_comp, BOOLEAN F4_mode)
+{
+  assume (r == currRing);
+  ring orig_ring = r;
+  int pos;
+  ring new_ring = rAssure_TDeg (orig_ring, 1, rVar (orig_ring), pos);
+  ideal s_h;
+  if (orig_ring != new_ring)
+  {
+    rChangeCurrRing (new_ring);
+    s_h = idrCopyR_NoSort (arg_I, orig_ring);
+    idTest (s_h);
+    /*int i;
+       for(i=0;i<IDELEMS(s_h);i++)
+       {
+       poly p=s_h->m[i];
+       while(p)
+       {
+       p_Setm(p,new_ring);
+       pIter(p);
+       }
+       } */
+  }
+  else
+  {
+    s_h = id_Copy (arg_I, orig_ring);
+  }
+
+  ideal s_result = do_t_rep_gb (new_ring, s_h, syz_comp, F4_mode, pos);
+  ideal result;
+  if (orig_ring != new_ring)
+  {
+    idTest (s_result);
+    rChangeCurrRing (orig_ring);
+    result = idrMoveR_NoSort (s_result, new_ring);
+
+    idTest (result);
+    //rChangeCurrRing(new_ring);
+    rKill (new_ring);
+    //rChangeCurrRing(orig_ring);
+  }
+  else
+    result = s_result;
+  idTest (result);
+  return result;
+}
+
+ideal
+do_t_rep_gb (ring r, ideal arg_I, int syz_comp, BOOLEAN F4_mode, int deg_pos)
 {
   //  Print("QlogSize(0) %d, QlogSize(1) %d,QlogSize(-2) %d, QlogSize(5) %d\n", QlogSize(nlInit(0)),QlogSize(nlInit(1)),QlogSize(nlInit(-2)),QlogSize(nlInit(5)));
@@ -3399,98 +3690,104 @@
   if (TEST_OPT_PROT)
     if (F4_mode)
-      PrintS("F4 Modus \n");
+      PrintS ("F4 Modus \n");
 
   //debug_Ideal=arg_debug_Ideal;
   //if (debug_Ideal) PrintS("DebugIdeal received\n");
   // Print("Idelems %i \n----------\n",IDELEMS(arg_I));
-  ideal I=arg_I;
-  idCompactify(I);
-  if (idIs0(I)) return I;
+  ideal I = arg_I;
+  idCompactify (I);
+  if (idIs0 (I))
+    return I;
   int i;
-  for(i=0;i<IDELEMS(I);i++)
-  {
-    assume(I->m[i]!=NULL);
-    simplify_poly(I->m[i],currRing);
-  }
-
-  qsort(I->m,IDELEMS(I),sizeof(poly),poly_crit);
+  for (i = 0; i < IDELEMS (I); i++)
+  {
+    assume (I->m[i] != NULL);
+    simplify_poly (I->m[i], currRing);
+  }
+
+  qsort (I->m, IDELEMS (I), sizeof (poly), poly_crit);
   //Print("Idelems %i \n----------\n",IDELEMS(I));
   //slimgb_alg* c=(slimgb_alg*) omalloc(sizeof(slimgb_alg));
   //int syz_comp=arg_I->rank;
-  slimgb_alg* c=new slimgb_alg(I, syz_comp,F4_mode,deg_pos);
-
-  while ((c->pair_top>=0) && ((!(TEST_OPT_DEGBOUND)) || (c->apairs[c->pair_top]->deg<=Kstd1_deg)))
-  {
-    #ifdef HAVE_F4
-    if(F4_mode)
-      go_on_F4(c);
+  slimgb_alg *c = new slimgb_alg (I, syz_comp, F4_mode, deg_pos);
+
+  while ((c->pair_top >= 0)
+	 && ((!(TEST_OPT_DEGBOUND))
+	     || (c->apairs[c->pair_top]->deg <= Kstd1_deg)))
+  {
+#ifdef HAVE_F4
+    if (F4_mode)
+      go_on_F4 (c);
     else
-    #endif
-      go_on(c);
-  }
-  if (c->pair_top<0)
-    c->completed=TRUE;
-  I=c->S;
+#endif
+      go_on (c);
+  }
+  if (c->pair_top < 0)
+    c->completed = TRUE;
+  I = c->S;
   delete c;
   if (TEST_OPT_REDSB)
   {
-    ideal erg=kInterRed(I,NULL);
-    assume(I!=erg);
-    id_Delete(&I, currRing);
+    ideal erg = kInterRed (I, NULL);
+    assume (I != erg);
+    id_Delete (&I, currRing);
     return erg;
   }
   //qsort(I->m, IDELEMS(I),sizeof(poly),pLmCmp_func);
-  assume(I->rank>=idRankFreeModule(I));
-  return(I);
-}
-
-void now_t_rep(const int & arg_i, const int & arg_j, slimgb_alg* c)
-{
-  int i,j;
-  if (arg_i==arg_j)
+  assume (I->rank >= idRankFreeModule (I));
+  return (I);
+}
+
+void
+now_t_rep (const int &arg_i, const int &arg_j, slimgb_alg * c)
+{
+  int i, j;
+  if (arg_i == arg_j)
   {
     return;
   }
-  if (arg_i>arg_j)
-  {
-    i=arg_j;
-    j=arg_i;
+  if (arg_i > arg_j)
+  {
+    i = arg_j;
+    j = arg_i;
   }
   else
   {
-    i=arg_i;
-    j=arg_j;
-  }
-  c->states[j][i]=HASTREP;
-}
-
-static BOOLEAN has_t_rep(const int & arg_i, const  int & arg_j, slimgb_alg* state)
-{
-  assume(0<=arg_i);
-  assume(0<=arg_j);
-  assume(arg_i<state->n);
-  assume(arg_j<state->n);
-  if (arg_i==arg_j)
+    i = arg_i;
+    j = arg_j;
+  }
+  c->states[j][i] = HASTREP;
+}
+
+static BOOLEAN
+has_t_rep (const int &arg_i, const int &arg_j, slimgb_alg * state)
+{
+  assume (0 <= arg_i);
+  assume (0 <= arg_j);
+  assume (arg_i < state->n);
+  assume (arg_j < state->n);
+  if (arg_i == arg_j)
   {
     return (TRUE);
   }
-  if (arg_i>arg_j)
-  {
-    return (state->states[arg_i][arg_j]==HASTREP);
+  if (arg_i > arg_j)
+  {
+    return (state->states[arg_i][arg_j] == HASTREP);
   }
   else
   {
-    return (state->states[arg_j][arg_i]==HASTREP);
-  }
-}
-
-#if 0 // unused
-static int pLcmDeg(poly a, poly b)
+    return (state->states[arg_j][arg_i] == HASTREP);
+  }
+}
+
+#if 0				// unused
+static int
+pLcmDeg (poly a, poly b)
 {
   int i;
-  int n=0;
-  for (i=pVariables; i; i--)
-  {
-    n+=si_max( pGetExp(a,i), pGetExp(b,i));
+  int n = 0;
+  for (i = pVariables; i; i--)
+  {
+    n += si_max (pGetExp (a, i), pGetExp (b, i));
   }
   return n;
